# -*- Python -*-

__version__ = '$Revision: 1.3 $'[11:-2]

from twisted.spread import pb

SOCKETNAME = ".freshcvs"

class VersionedPatch(pb.Copyable, pb.RemoteCopy):
    """
    @type filename: string
    @type pathname: string
    @type r1: tuple
    @type r2: tuple
    """
    filename = None
    pathname = None
    r1 = None
    r2 = None

    def __init__(self, filename=None, r1=None, r2=None):
        if filename is not None:
            self.filename = filename
        if r1 is not None:
            self.r1 = r1
        if r2 is not None:
            self.r2 = r2

    def __str__(self):
        if self.pathname is not None:
            p = self.pathname + '/'
        else:
            p = ''
        return '%s%s %s,%s' % (p, self.filename, self.r1, self.r2)

    def getTypeToCopy(self):
        return 'CVSToys.VersionedPatch'


class Directory(pb.Copyable, pb.RemoteCopy):
    """
    @ivar filename:
    @type filename: string
    @ivar pathname:
    @type pathname: string
    """
    def __init__(self, filename=None):
        if filename is not None:
            self.filename = filename

    def __str__(self):
        if self.pathname is not None:
            return '%s/%s' % (self.pathname, self.filename)
        else:
            return self.filename

    def getTypeToCopy(self):
        return 'CVSToys.Directory'


class NewImport(pb.Copyable, pb.RemoteCopy):
    def getTypeToCopy(self):
        return 'CVSToys.NewImport'


for klass in VersionedPatch, Directory:
    pb.setCopierForClass(klass().getTypeToCopy(), klass)
