# -*- Python -*-

from twisted.python import components

class INotifieeClient(components.Interface):
    def remote_notify(self, root, files, message, user):
        pass

    def remote_goodbye(self, message):
        """The server is asking you to leave now."""
        pass

class ICommitAction(components.Interface):
    """An action to take when a commit is done.
    """

    def __call__(self, root, files, message, user):
        """I am called upon when there's action to be done.

        @param root: the $CVSROOT of this repository.
        @type root: string
        @param files: a list of files to act upon.
        @type files: L{common.VersionedPatch}
        @param message: the commit log message
        @type message: string

        @returns: Deferred
        """

        raise NotImplementedError, "subclass should implement me!"

    def unload(self):
        """Called when the current configuation is about to be discarded.

        Should return a Deferred to indicate when it is done."""
        raise NotImplemented
